#!/bin/sh
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2003, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# IBM_COPYRIGHT_END

#
# -----------------------------------------------------------------
# Licensed Materials - Property of IBM
# 5724-F75
# (C) Copyright IBM Corp.  2003, 2004
# All Rights Reserved
# US Government Users Restricted Rights -Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# -----------------------------------------------------------------

#set -x

ProgName=`basename $0`
# Check the number of input parameters
test $# -lt 3 && {
        echo "Usage $ProgName: user ipaddress timeout"
        exit 1
}

user=$1
ipaddress=$2
timeout="$3" 	# the input is in sec

# Set the start time in seconds
hour=`date +"%H"`
min=`date +"%M"`
sec=`date +"%S"`
nano=`date +"%N" | cut -c1-3`
start_time=`expr ${hour} \* 3600 + ${min} \* 60 + ${sec}`
start_time=`expr ${start_time} \* 1000 + ${nano}`

elapsed_time=0

while [ ${elapsed_time} -lt ${timeout} ]
do
	ssh ${user}@${ipaddress} 'echo works' 1>/dev/null 2>/dev/null
	return=$?
	# Find the current time in seconds
	hours=`date +"%H"`
	min=`date +"%M"`
	sec=`date +"%S"`
	nano=`date +"%N" | cut -c1-3`
	cur_time=`expr ${hour} \* 3600 + ${min} \* 60 + ${sec}`
	cur_time=`expr ${cur_time} \* 1000 + ${nano}`
	elapsed_time=`expr ${cur_time} - ${start_time}`
	test ${return} = 0 && {
		echo "${elapsed_time}"
		break
	}
done
exit ${return}
