-- Licensed Materials - Property of IBM
-- 
-- (C) Copyright IBM Corp. 2007, 2011 All Rights Reserved
-- 
-- US Government Users Restricted Rights - Use, duplicate or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
CREATE TABLE OPENJPA_SEQUENCE_TABLE (ID NUMBER NOT NULL, SEQUENCE_VALUE NUMBER, PRIMARY KEY (ID));
CREATE TABLE WKF_DCM_OBJECT (DCM_OBJECT_ID NUMBER NOT NULL, CREATE_TS TIMESTAMP, description VARCHAR2(2000), DISPLAY_NAME VARCHAR2(256), guid VARCHAR2(32), locale VARCHAR2(256), LOCKED_UNTIL NUMBER, MODIFY_TS TIMESTAMP, name VARCHAR2(765), NAME_LOWER_CASE VARCHAR2(765), ROW_VERSION NUMBER, SOURCE_TOKENS VARCHAR2(1024), DEVICE_MODEL_ID NUMBER, PHYSICAL_CONTAINER_ID NUMBER, TYPE_ID NUMBER NOT NULL, PRIMARY KEY (DCM_OBJECT_ID));
CREATE TABLE WKF_DCM_OBJECT_TYPE (TYPE_ID NUMBER NOT NULL, description VARCHAR2(2000), name VARCHAR2(256) NOT NULL, SUPER_TYPE_ID NUMBER, PRIMARY KEY (TYPE_ID));
CREATE TABLE WKF_DCM_OBJECT_WORKFLOW (DCM_OBJECT_WORKFLOW_ID NUMBER NOT NULL, WORKFLOW_NAME VARCHAR2(255) NOT NULL, DCM_OBJECT_ID NUMBER NOT NULL, PRIMARY KEY (DCM_OBJECT_WORKFLOW_ID));
CREATE TABLE WKF_DEPLOYMENT_REQUEST (DEPLOYMENT_REQUEST_ID NUMBER NOT NULL, attempts NUMBER, IS_CANCELLED VARCHAR2(1) NOT NULL, CREATE_DATETIME TIMESTAMP NOT NULL, CREATE_USERNAME VARCHAR2(256), ERROR_CODE VARCHAR2(255), ERROR_DETAIL CLOB, ERROR_MESSAGE VARCHAR2(4000), guid VARCHAR2(128), IS_IN_PROGRESS VARCHAR2(1) NOT NULL, PENDING_ACTION VARCHAR2(20), PENDING_INTERACTION_REQUEST_ID NUMBER, IS_SUCCESSFUL VARCHAR2(1) NOT NULL, WORKFLOW_NAME VARCHAR2(255), PRIMARY KEY (DEPLOYMENT_REQUEST_ID));
CREATE TABLE WKF_DEVICE_MODEL (DEVICE_MODEL_ID NUMBER NOT NULL, category VARCHAR2(255), description CLOB, descriptor CLOB, name VARCHAR2(255), TCDRIVER_ID NUMBER, DCM_OBJECT_ID NUMBER, PRIMARY KEY (DEVICE_MODEL_ID));
CREATE TABLE WKF_EXCEPTION_HANDLER (EXCEPTION_HANDLER_ID NUMBER NOT NULL, EXCEPTION_TYPE VARCHAR2(256), FIRST_INSTRUCTION_INDEX NUMBER NOT NULL, HANDLER_POSITION NUMBER NOT NULL, HANDLER_TYPE VARCHAR2(256) NOT NULL, INSTRUCTION_ID NUMBER NOT NULL, PRIMARY KEY (EXCEPTION_HANDLER_ID));
CREATE TABLE WKF_EXECUTION_LOG (LOG_ID NUMBER NOT NULL, CALL_STACK_LEVEL NUMBER NOT NULL, datetime TIMESTAMP NOT NULL, LOG_LEVEL VARCHAR2(256) NOT NULL, position NUMBER NOT NULL, RECORD_TYPE VARCHAR2(30), text VARCHAR2(4000), WORKFLOW_NAME VARCHAR2(255) NOT NULL, DEPLOYMENT_REQUEST_ID NUMBER NOT NULL, PRIMARY KEY (LOG_ID));
CREATE TABLE WKF_EXECUTION_LOG_DETAIL (WF_EXEC_LOG_DETAIL_ID NUMBER NOT NULL, ARRAY_INDEX NUMBER, IS_ENCRYPTED VARCHAR2(1) NOT NULL, name VARCHAR2(256) NOT NULL, position NUMBER NOT NULL, value VARCHAR2(4000), LOG_ID NUMBER NOT NULL, PRIMARY KEY (WF_EXEC_LOG_DETAIL_ID));
CREATE TABLE WKF_FORMAL_PARAMETER (FORMAL_PARAMETER_ID NUMBER NOT NULL, IS_ARRAY VARCHAR2(1) NOT NULL, IS_ENCRYPTED VARCHAR2(1) NOT NULL, IS_INPUT VARCHAR2(1) NOT NULL, PARAMETER_NAME VARCHAR2(256) NOT NULL, IS_OUTPUT VARCHAR2(1) NOT NULL, PARAMETER_POSITION NUMBER NOT NULL, WORKFLOW_ID NUMBER NOT NULL, PRIMARY KEY (FORMAL_PARAMETER_ID));
CREATE TABLE WKF_FORMAL_PARM_PERM (FORMAL_PARAMETER_PERMISSION_ID NUMBER NOT NULL, INSTANCE_PERMISSION_ID NUMBER NOT NULL, FORMAL_PARAMETER_ID NUMBER NOT NULL, PRIMARY KEY (FORMAL_PARAMETER_PERMISSION_ID));
CREATE TABLE WKF_INSTRUCTION (INSTRUCTION_ID NUMBER NOT NULL, INSTRUCTION_INDEX NUMBER NOT NULL, IS_XA VARCHAR2(1) NOT NULL, opcode VARCHAR2(256) NOT NULL, SOURCE_COLUMN NUMBER NOT NULL, SOURCE_LINE NUMBER NOT NULL, WORKFLOW_ID NUMBER NOT NULL, PRIMARY KEY (INSTRUCTION_ID));
CREATE TABLE WKF_INSTRUCTION_OPERAND (OPERAND_ID NUMBER NOT NULL, OPERAND_INDEX NUMBER NOT NULL, OPERAND_NAME VARCHAR2(256) NOT NULL, OPERAND_TYPE VARCHAR2(256) NOT NULL, SOURCE_COLUMN NUMBER NOT NULL, SOURCE_LINE NUMBER NOT NULL, INSTRUCTION_ID NUMBER NOT NULL, WORKFLOW_ID NUMBER NOT NULL, IS_EMPTY_STRING VARCHAR2(1), STRING_VALUE VARCHAR2(4000), NAME_VALUE VARCHAR2(256), CLOB_VALUE CLOB, INTEGER_VALUE NUMBER, BOOLEAN_VALUE VARCHAR2(1), PRIMARY KEY (OPERAND_ID));
CREATE TABLE WKF_JAVA_PLUGIN (JAVA_PLUGIN_ID NUMBER NOT NULL, deprecated VARCHAR2(2000), description VARCHAR2(2000), CLASS_NAME VARCHAR2(255), name VARCHAR2(256) NOT NULL, TCDRIVER_ID NUMBER, PRIMARY KEY (JAVA_PLUGIN_ID));
CREATE TABLE WKF_JAVA_PLUGIN_PARAMETER (JAVA_PLUGIN_PARAMETER_ID NUMBER NOT NULL, array NUMBER, defaultValue VARCHAR2(255), IS_ENCRYPTED VARCHAR2(1) NOT NULL, IS_INPUT VARCHAR2(1) NOT NULL, IS_OUTPUT VARCHAR2(1) NOT NULL, PARAMETER_NAME VARCHAR2(256) NOT NULL, JAVA_PLUGIN_ID NUMBER NOT NULL, PRIMARY KEY (JAVA_PLUGIN_PARAMETER_ID));
CREATE TABLE WKF_REQUEST_CONTEXT_VARIABLE (REQUEST_CONTEXT_VARIABLE_ID NUMBER NOT NULL, ARRAY_INDEX NUMBER, description VARCHAR2(2000), ENCRYPTED_B VARCHAR2(1) NOT NULL, guid VARCHAR2(128), INPUT_B VARCHAR2(1) NOT NULL, name VARCHAR2(256) NOT NULL, OUTPUT_B VARCHAR2(1) NOT NULL, OUTPUT_VALUE VARCHAR2(4000), value VARCHAR2(4000), DEPLOYMENT_REQUEST_ID NUMBER NOT NULL, PRIMARY KEY (REQUEST_CONTEXT_VARIABLE_ID));
CREATE TABLE WKF_REQUEST_PARAM (REQUEST_CONTEXT_VARIABLE_ID NUMBER NOT NULL, array NUMBER, description VARCHAR2(2000), ENCRYPTED_B VARCHAR2(1) NOT NULL, guid VARCHAR2(128), ARRAY_INDEX NUMBER NOT NULL, INPUT_B VARCHAR2(1) NOT NULL, inputValue VARCHAR2(4000), name VARCHAR2(256) NOT NULL, OUTPUT_B VARCHAR2(1) NOT NULL, OUTPUT_VALUE VARCHAR2(4000), DEPLOYMENT_REQUEST_ID NUMBER NOT NULL, PRIMARY KEY (REQUEST_CONTEXT_VARIABLE_ID));
CREATE TABLE WKF_RESOURCE_REQUEST_LOCK (RESOURCE_REQUEST_LOCK_KEY_ID NUMBER NOT NULL, ACQUIRE_DATETIME TIMESTAMP, DCM_OBJECT_ID NUMBER NOT NULL, LOCK_KEY NUMBER, DEPLOYMENT_REQUEST_ID NUMBER NOT NULL, PRIMARY KEY (RESOURCE_REQUEST_LOCK_KEY_ID));
CREATE TABLE WKF_TCDRIVER (TCDRIVER_ID NUMBER NOT NULL, descriptor CLOB, name VARCHAR2(255), version VARCHAR2(256) NOT NULL, PRIMARY KEY (TCDRIVER_ID));
CREATE TABLE WKF_TCDRIVER_FILE (TCDRIVER_FILE_ID NUMBER NOT NULL, destination VARCHAR2(2000) NOT NULL, source VARCHAR2(2000) NOT NULL, type VARCHAR2(256), TCDRIVER_ID NUMBER NOT NULL, PRIMARY KEY (TCDRIVER_FILE_ID));
CREATE TABLE WKF_WORKFLOW (WORKFLOW_ID NUMBER NOT NULL, deprecated VARCHAR2(2000), DEVICE_MODEL VARCHAR2(255), IMPLEMENTS_LDO VARCHAR2(255), IS_EDITABLE VARCHAR2(1) NOT NULL, IS_LOGICAL_OPERATION VARCHAR2(1) NOT NULL, LEGACY_WORKFLOW_ID VARCHAR2(36), LOCALE_SENSITIVE VARCHAR2(1) NOT NULL, WORKFLOW_NAME VARCHAR2(255) NOT NULL, DTYPE VARCHAR2(255), TCDRIVER_ID NUMBER, SOURCE_CODE CLOB, PRIMARY KEY (WORKFLOW_ID));
CREATE INDEX I_WKF_JCT_DCMOBJECT ON WKF_DCM_OBJECT (PHYSICAL_CONTAINER_ID);
CREATE INDEX I_WKF_JCT_DCMOBJECTTYPE ON WKF_DCM_OBJECT (TYPE_ID);
CREATE INDEX I_WKF_JCT_DEVICEMODEL2 ON WKF_DCM_OBJECT (DEVICE_MODEL_ID);
CREATE INDEX I_WKF_FLW_DCMOBJECT ON WKF_DCM_OBJECT_WORKFLOW (DCM_OBJECT_ID);
CREATE INDEX I_WKF_MDL_DCMOBJECT ON WKF_DEVICE_MODEL (DCM_OBJECT_ID);
CREATE INDEX I_WKF_MDL_TCDRIVER ON WKF_DEVICE_MODEL (TCDRIVER_ID);
CREATE INDEX I_WKF_DLR_INSTRUCTION ON WKF_EXCEPTION_HANDLER (INSTRUCTION_ID);
CREATE INDEX I_WKF__LG_DEPLOYMENTREQUEST ON WKF_EXECUTION_LOG (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_DTL_WORKFLOWEXECUTIONLOG ON WKF_EXECUTION_LOG_DETAIL (LOG_ID);
CREATE INDEX I_WKF_MTR_WORKFLOW ON WKF_FORMAL_PARAMETER (WORKFLOW_ID);
CREATE INDEX I_WKF_PRM_FORMALPARAMETER ON WKF_FORMAL_PARM_PERM (FORMAL_PARAMETER_ID);
CREATE INDEX I_WKF_CTN_WORKFLOW ON WKF_INSTRUCTION (WORKFLOW_ID);
CREATE INDEX I_WKF_RND_DTYPE ON WKF_INSTRUCTION_OPERAND (OPERAND_TYPE);
CREATE INDEX I_WKF_RND_INSTRUCTION ON WKF_INSTRUCTION_OPERAND (INSTRUCTION_ID);
CREATE INDEX I_WKF_RND_WORKFLOW ON WKF_INSTRUCTION_OPERAND (WORKFLOW_ID);
CREATE INDEX I_WKF_LGN_TCDRIVER ON WKF_JAVA_PLUGIN (TCDRIVER_ID);
CREATE INDEX I_WKF_MTR_JAVAPLUGININFO ON WKF_JAVA_PLUGIN_PARAMETER (JAVA_PLUGIN_ID);
CREATE INDEX I_WKF_RBL_DEPLOYMENTREQUEST ON WKF_REQUEST_CONTEXT_VARIABLE (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_PRM_DEPLOYMENTREQUEST ON WKF_REQUEST_PARAM (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_LCK_DEPLOYMENTREQUEST ON WKF_RESOURCE_REQUEST_LOCK (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF__FL_TCDRIVER ON WKF_TCDRIVER_FILE (TCDRIVER_ID);
CREATE INDEX I_WKF_FLW_DTYPE ON WKF_WORKFLOW (DTYPE);
CREATE INDEX I_WKF_FLW_TCDRIVER ON WKF_WORKFLOW (TCDRIVER_ID);
