' Licensed Materials - Property of IBM
'
' (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved
'
' US Government Users Restricted Rights - Use, duplicate or
' disclosure restricted by GSA ADP Schedule Contract with
' IBM Corp.
' IBM_COPYRIGHT_END


'  
' ============================================================================ 

Function ReplaceChars(RESULT)
     Dim lookFor(6), repLace(6)
     lookFor(0) = "&"
     lookFor(1) = "%"
     lookFor(2) = """"
     lookFor(3) = "<"
     lookFor(4) = ">"
     lookFor(5) = "\\"
     repLace(0) = "&amp;"
     repLace(1) = "&#37;"
     repLace(2) = "&quot;"
     repLace(3) = "&lt;"
     repLace(4) = "&gt;"
     repLace(5) = "\\\\\\"

     set objRE = new RegExp
     objRE.Global = True
     objRE.IgnoreCase = True
     objRE.MultiLine = True

     For i = 0 To Ubound(lookFor)-1 Step 1
          objRE.pattern = lookFor(i)
          replaceString = repLace(i)
          RESULT = objRE.Replace(RESULT, replaceString)
     Next
     ReplaceChars = RESULT
End Function


Function TIOthrow (EXCEPTION, MESSAGE)
  MESSAGE = ReplaceChars(MESSAGE)
  WScript.Echo "<tio><throw exception=""" & EXCEPTION & """>" & MESSAGE & "</throw></tio>"
End Function


Function TIOlog (LEVEL, MESSAGE)
  MESSAGE = ReplaceChars(MESSAGE)
  WScript.Echo "<tio><log level=""" & LEVEL & """>" & MESSAGE & "</log></tio>"
End Function


Set args = WScript.Arguments
fileName = args(0)
filePath = args(1)
content = args(2)

TIOlog "debug", "VBS script started"

Dim location
If (StrComp(Right(filePath, 1), "\") = 0) Then
  location = filePath & fileName
Else
  location = filePath & "\" & fileName
End If

Dim oFSO : Set oFSO = CreateObject("Scripting.FileSystemObject")

If (not oFSO.FileExists(location)) Then
  TIOThrow "FileDoesNotExist", "The file does not exist at the following path:  " & location
  WScript.Quit 1
End If

Dim backupLocation
backupLocation = location & ".backup"

If (oFSO.FileExists(backupLocation)) Then
  oFSO.DeleteFile backupLocation, True
End If

oFSO.MoveFile location, backupLocation

Dim orig
Set orig = oFSO.OpenTextFile(backupLocation, 1, False)
Dim originalContent
originalContent = orig.ReadAll()
orig.Close

Dim dest
Set dest = oFSO.CreateTextFile(location, True)
dest.WriteLine content
dest.Write originalContent
dest.Close
